'use strict';

exports.__esModule = true;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _flowAppComponent = require('flow-app-component');

var _flowAppComponent2 = _interopRequireDefault(_flowAppComponent);

require('./css/theme/default.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var FormComponent = function (_AppComponent) {
  _inherits(FormComponent, _AppComponent);

  function FormComponent() {
    _classCallCheck(this, FormComponent);

    var _this = _possibleConstructorReturn(this, _AppComponent.call(this));

    var newState = {
      properties: [{
        categoryName: 'General',
        categoryDescription: 'Basic settings for the form',
        properties: []
      }, {
        categoryName: 'Events',
        categoryDescription: 'Events for the form',
        properties: [{
          id: 'event',
          name: 'Events',
          type: 'graph',
          options: {},
          data: null
        }]
      }],
      iconUrl: '/assets/images/form-component.png',
      name: 'Form',
      type: 'ui-component',
      componentType: 'form',
      category: 'Inputs',
      parent: null,
      showOnComponentsPanel: true,
      isValuable: true,
      allowsChildren: true,
      allowedChildTypes: ['checkbox', 'container', 'link', 'input', 'search', 'text', 'loader', 'radio', 'map', 'dropdown']
    };

    _this.state = Object.assign(_this.state, newState); // merge two states together, and dont lose any parent state properties.
    return _this;
  }

  FormComponent.prototype.renderContent = function renderContent() {
    var customStyles = {};
    if (!this.props.hasChildren) {
      customStyles = {
        display: 'flex',
        alignItems: 'center',
        justifyContent: 'center',
        height: '70px'
      };
    }
    return _react2.default.createElement(
      'div',
      { className: 'form-container', style: customStyles },
      !this.props.hasChildren && _react2.default.createElement(
        'span',
        null,
        'Drag fields in here'
      ),
      this.renderChildren()
    );
  };

  return FormComponent;
}(_flowAppComponent2.default);

exports.default = FormComponent;
module.exports = exports['default'];